/*
 File: rules_phrase_thsym.cpp
 Date and Time: Fri Jan 30 18:55:23 2015 
*/
#include "rules_phrase_th.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_rules_phrase_th;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_rules_phrase_th::TH_rules_phrase_th(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_rules_phrase_th;
  NS_rules_phrase_th::Crules_phrase_th Crules_phrase_th_;// parallel-parser's parse table
#define ssPARSE_TABLE Crules_phrase_th_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_rules_phrase_th::PROC_TH_rules_phrase_th(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_rules_phrase_th";
  static bool one_time(false);
  static NS_rules_phrase_th::Crules_phrase_th* NS_rules_phrase_th_Crules_phrase_th_(0);// parallel-parser's fsm table
  static Parser* NS_rules_phrase_th_Crules_phrase_th_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_rules_phrase_th_Crules_phrase_th_ = new NS_rules_phrase_th::Crules_phrase_th();// parallel-parser's fsm table
    NS_rules_phrase_th_Crules_phrase_th_parser = new Parser(*NS_rules_phrase_th_Crules_phrase_th_,Caller_pp);
  }
 proc_parser = NS_rules_phrase_th_Crules_phrase_th_parser;
#include "wproc_pp_core.h"
}
void 
Crules_phrase_th::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rrules_phrase_:{
       Rrules_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrules_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs1_Rrule_defs_phrase_:{
       Rrule_defs_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrule_defs_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_defs_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     return;}
    case rhs1_Rrule_defs_:{
       Rrule_defs* sym;
     if(re->rule_ == 0){
       sym = new Rrule_defs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_defs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rrule_defs_:{
       Rrule_defs* sym;
     if(re->rule_ == 0){
       sym = new Rrule_defs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_defs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rrule_def1_:{
       Rrule_def1* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rrule_def1_:{
       Rrule_def1* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs1_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_brace_:{
       Ropen_brace* sym;
     if(re->rule_ == 0){
       sym = new Ropen_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_brace_:{
       Rclose_brace* sym;
     if(re->rule_ == 0){
       sym = new Rclose_brace(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_brace*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rlint_or_cweb_or_error_:{
       Rlint_or_cweb_or_error* sym;
     if(re->rule_ == 0){
       sym = new Rlint_or_cweb_or_error(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_or_cweb_or_error*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rlint_or_cweb_or_error_:{
       Rlint_or_cweb_or_error* sym;
     if(re->rule_ == 0){
       sym = new Rlint_or_cweb_or_error(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_or_cweb_or_error*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs3_Rlint_or_cweb_or_error_:{
       Rlint_or_cweb_or_error* sym;
     if(re->rule_ == 0){
       sym = new Rlint_or_cweb_or_error(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_or_cweb_or_error*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rlint_or_cweb_:{
       Rlint_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rlint_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rlint_or_cweb_:{
       Rlint_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rlint_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rfluffs_or_cweb_:{
       Rfluffs_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluffs_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluffs_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rfluffs_or_cweb_:{
       Rfluffs_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluffs_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluffs_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rfluff_or_cweb_:{
       Rfluff_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluff_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rfluff_or_cweb_:{
       Rfluff_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluff_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rfluff_or_cweb_:{
       Rfluff_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluff_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rfluff_or_cweb_:{
       Rfluff_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluff_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     return;}
    case rhs5_Rfluff_or_cweb_:{
       Rfluff_or_cweb* sym;
     if(re->rule_ == 0){
       sym = new Rfluff_or_cweb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff_or_cweb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    default: return;
   }
}
